summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorSaumit Dinesan <justsaumit@protonmail.com>2022-11-30 16:18:18 +0530
committerSaumit Dinesan <justsaumit@protonmail.com>2022-11-30 16:18:18 +0530
commit7e19ac71731340dda02ffedde8b2f7cce5ecf73e (patch)
treec8595f1448c8c8d9d0f7b12fd89a09d82857129e
parent92e4a6e8610c49b500935ee23a4a6256b55b44a5 (diff)
st ext-pipe scripts
-rwxr-xr-x.local/bin/st-copyout9
-rwxr-xr-x.local/bin/st-urlhandler19
l---------.scripts/st-copyout1
l---------.scripts/st-urlhandler1
4 files changed, 28 insertions, 2 deletions
diff --git a/.local/bin/st-copyout b/.local/bin/st-copyout
new file mode 100755
index 0000000..50e0531
--- /dev/null
+++ b/.local/bin/st-copyout
@@ -0,0 +1,9 @@
+#!/bin/sh
+tmpfile=$(mktemp /tmp/st-cmd-output.XXXXXX)
+trap 'rm "$tmpfile"' 0 1 15
+sed -n "w $tmpfile"
+sed -i 's/\x0//g' "$tmpfile"
+ps1="$(grep "\S" "$tmpfile" | tail -n 1 | sed 's/^\s*//' | cut -d' ' -f1)"
+chosen="$(grep -F "$ps1" "$tmpfile" | sed '$ d' | tac | dmenu -p "Copy which command's output?" -i -l 10 | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+eps1="$(echo "$ps1" | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+awk "/^$chosen$/{p=1;print;next} p&&/$eps1/{p=0};p" "$tmpfile" | xclip -sel c
diff --git a/.local/bin/st-urlhandler b/.local/bin/st-urlhandler
new file mode 100755
index 0000000..7086f2f
--- /dev/null
+++ b/.local/bin/st-urlhandler
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+urlregex="(((http|https|gopher|gemini|ftp|ftps|git)://|www\\.)[a-zA-Z0-9.]*[:;a-zA-Z0-9./+@$&%?$\#=_~-]*)|((magnet:\\?xt=urn:btih:)[a-zA-Z0-9]*)"
+
+urls="$(sed 's/.*│//g' | tr -d '\n' | # First remove linebreaks and mutt sidebars:
+ grep -aEo "$urlregex" | # grep only urls as defined above.
+ uniq | # Ignore neighboring duplicates.
+ sed "s/\(\.\|,\|;\|\!\\|\?\)$//;
+ s/^www./http:\/\/www\./")" # xdg-open will not detect url without http
+
+[ -z "$urls" ] && exit 1
+
+while getopts "hoc" o; do case "${o}" in
+ h) printf "Optional arguments for custom use:\\n -c: copy\\n -o: xdg-open\\n -h: Show this message\\n" && exit 1 ;;
+ o) chosen="$(echo "$urls" | dmenu -i -p 'Open which url?' -l 10)"
+ setsid xdg-open "$chosen" >/dev/null 2>&1 & ;;
+ c) echo "$urls" | dmenu -i -p 'Copy which url?' -l 10 | tr -d '\n' | xclip -selection clipboard ;;
+ *) printf "Invalid option: -%s\\n" "$OPTARG" && exit 1 ;;
+esac done
diff --git a/.scripts/st-copyout b/.scripts/st-copyout
deleted file mode 120000
index e822e4a..0000000
--- a/.scripts/st-copyout
+++ /dev/null
@@ -1 +0,0 @@
-/home/saumit/.local/src/st/external-pipe_scripts/st-copyout \ No newline at end of file
diff --git a/.scripts/st-urlhandler b/.scripts/st-urlhandler
deleted file mode 120000
index 0d8625f..0000000
--- a/.scripts/st-urlhandler
+++ /dev/null
@@ -1 +0,0 @@
-/home/saumit/.local/src/st/external-pipe_scripts/st-urlhandler \ No newline at end of file